Index: palm/trunk/SOURCE/salsa_mod.f90
===================================================================
--- palm/trunk/SOURCE/salsa_mod.f90	(revision 4130)
+++ palm/trunk/SOURCE/salsa_mod.f90	(revision 4131)
@@ -1538,18 +1279,314 @@
     ENDIF
 !
-!-- Partition and dissolutional growth by gaseous HNO3 and NH3
-    IF ( index_no > 0  .AND.  index_nh > 0  .AND.  index_so4 > 0 )  lspartition = .TRUE.
+!-- Allocate:
+    ALLOCATE( aero(nbins_aerosol), bc_am_t_val(nbins_aerosol*ncomponents_mass),                    &
+              bc_an_t_val(nbins_aerosol), bc_gt_t_val(ngases_salsa), bin_low_limits(nbins_aerosol),&
+              nsect(nbins_aerosol), massacc(nbins_aerosol) )
+    ALLOCATE( k_topo_top(nysg:nyng,nxlg:nxrg) )
+    IF ( nldepo ) ALLOCATE( sedim_vd(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
+    ALLOCATE( ra_dry(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
+!
+!-- Initialise the sectional particle size distribution
+    CALL set_sizebins
+!
+!-- Aerosol number concentration
+    ALLOCATE( aerosol_number(nbins_aerosol) )
+    ALLOCATE( nconc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol),                                &
+              nconc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol),                                &
+              nconc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg,nbins_aerosol) )
+    nconc_1 = 0.0_wp
+    nconc_2 = 0.0_wp
+    nconc_3 = 0.0_wp
+
+    DO i = 1, nbins_aerosol
+       aerosol_number(i)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => nconc_1(:,:,:,i)
+       aerosol_number(i)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => nconc_2(:,:,:,i)
+       aerosol_number(i)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => nconc_3(:,:,:,i)
+       ALLOCATE( aerosol_number(i)%flux_s(nzb+1:nzt,0:threads_per_task-1),                         &
+                 aerosol_number(i)%diss_s(nzb+1:nzt,0:threads_per_task-1),                         &
+                 aerosol_number(i)%flux_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),                 &
+                 aerosol_number(i)%diss_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),                 &
+                 aerosol_number(i)%init(nzb:nzt+1),                                                &
+                 aerosol_number(i)%sums_ws_l(nzb:nzt+1,0:threads_per_task-1) )
+       aerosol_number(i)%init = nclim
+       IF ( include_emission  .OR.  ( nldepo  .AND.  nldepo_surf ) )  THEN
+          ALLOCATE( aerosol_number(i)%source(nys:nyn,nxl:nxr) )
+          aerosol_number(i)%source = 0.0_wp
+       ENDIF
+    ENDDO
+
+!
+!-- Aerosol mass concentration
+    ALLOCATE( aerosol_mass(ncomponents_mass*nbins_aerosol) )
+    ALLOCATE( mconc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ncomponents_mass*nbins_aerosol),               &
+              mconc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ncomponents_mass*nbins_aerosol),               &
+              mconc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ncomponents_mass*nbins_aerosol) )
+    mconc_1 = 0.0_wp
+    mconc_2 = 0.0_wp
+    mconc_3 = 0.0_wp
+
+    DO i = 1, ncomponents_mass*nbins_aerosol
+       aerosol_mass(i)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => mconc_1(:,:,:,i)
+       aerosol_mass(i)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => mconc_2(:,:,:,i)
+       aerosol_mass(i)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => mconc_3(:,:,:,i)
+       ALLOCATE( aerosol_mass(i)%flux_s(nzb+1:nzt,0:threads_per_task-1),                           &
+                 aerosol_mass(i)%diss_s(nzb+1:nzt,0:threads_per_task-1),                           &
+                 aerosol_mass(i)%flux_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),                   &
+                 aerosol_mass(i)%diss_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),                   &
+                 aerosol_mass(i)%init(nzb:nzt+1),                                                  &
+                 aerosol_mass(i)%sums_ws_l(nzb:nzt+1,0:threads_per_task-1)  )
+       aerosol_mass(i)%init = mclim
+       IF ( include_emission  .OR.  ( nldepo  .AND.  nldepo_surf ) )  THEN
+          ALLOCATE( aerosol_mass(i)%source(nys:nyn,nxl:nxr) )
+          aerosol_mass(i)%source = 0.0_wp
+       ENDIF
+    ENDDO
+
+!
+!-- Surface fluxes: answs = aerosol number, amsws = aerosol mass
+!
+!-- Horizontal surfaces: default type
+    DO  l = 0, 2   ! upward (l=0), downward (l=1) and model top (l=2)
+       ALLOCATE( surf_def_h(l)%answs( 1:surf_def_h(l)%ns, nbins_aerosol ) )
+       ALLOCATE( surf_def_h(l)%amsws( 1:surf_def_h(l)%ns, nbins_aerosol*ncomponents_mass ) )
+       surf_def_h(l)%answs = 0.0_wp
+       surf_def_h(l)%amsws = 0.0_wp
+    ENDDO
+!
+!-- Horizontal surfaces: natural type
+    ALLOCATE( surf_lsm_h%answs( 1:surf_lsm_h%ns, nbins_aerosol ) )
+    ALLOCATE( surf_lsm_h%amsws( 1:surf_lsm_h%ns, nbins_aerosol*ncomponents_mass ) )
+    surf_lsm_h%answs = 0.0_wp
+    surf_lsm_h%amsws = 0.0_wp
+!
+!-- Horizontal surfaces: urban type
+    ALLOCATE( surf_usm_h%answs( 1:surf_usm_h%ns, nbins_aerosol ) )
+    ALLOCATE( surf_usm_h%amsws( 1:surf_usm_h%ns, nbins_aerosol*ncomponents_mass ) )
+    surf_usm_h%answs = 0.0_wp
+    surf_usm_h%amsws = 0.0_wp
+
+!
+!-- Vertical surfaces: northward (l=0), southward (l=1), eastward (l=2) and westward (l=3) facing
+    DO  l = 0, 3
+       ALLOCATE( surf_def_v(l)%answs( 1:surf_def_v(l)%ns, nbins_aerosol ) )
+       surf_def_v(l)%answs = 0.0_wp
+       ALLOCATE( surf_def_v(l)%amsws( 1:surf_def_v(l)%ns, nbins_aerosol*ncomponents_mass ) )
+       surf_def_v(l)%amsws = 0.0_wp
+
+       ALLOCATE( surf_lsm_v(l)%answs( 1:surf_lsm_v(l)%ns, nbins_aerosol ) )
+       surf_lsm_v(l)%answs = 0.0_wp
+       ALLOCATE( surf_lsm_v(l)%amsws( 1:surf_lsm_v(l)%ns, nbins_aerosol*ncomponents_mass ) )
+       surf_lsm_v(l)%amsws = 0.0_wp
+
+       ALLOCATE( surf_usm_v(l)%answs( 1:surf_usm_v(l)%ns, nbins_aerosol ) )
+       surf_usm_v(l)%answs = 0.0_wp
+       ALLOCATE( surf_usm_v(l)%amsws( 1:surf_usm_v(l)%ns, nbins_aerosol*ncomponents_mass ) )
+       surf_usm_v(l)%amsws = 0.0_wp
+
+    ENDDO
+
+!
+!-- Concentration of gaseous tracers (1. SO4, 2. HNO3, 3. NH3, 4. OCNV, 5. OCSV)
+!-- (number concentration (#/m3) )
+!
+!-- If chemistry is on, read gas phase concentrations from there. Otherwise, 
+!-- allocate salsa_gas array.
+
+    IF ( air_chemistry )  THEN
+       DO  lsp = 1, nvar
+          SELECT CASE ( TRIM( chem_species(lsp)%name ) )
+             CASE ( 'H2SO4', 'h2so4' )
+                gases_available = gases_available + 1
+                gas_index_chem(1) = lsp
+             CASE ( 'HNO3', 'hno3' )
+                gases_available = gases_available + 1
+                gas_index_chem(2) = lsp
+             CASE ( 'NH3', 'nh3' )
+                gases_available = gases_available + 1
+                gas_index_chem(3) = lsp
+             CASE ( 'OCNV', 'ocnv' )
+                gases_available = gases_available + 1
+                gas_index_chem(4) = lsp
+             CASE ( 'OCSV', 'ocsv' )
+                gases_available = gases_available + 1
+                gas_index_chem(5) = lsp
+          END SELECT
+       ENDDO
+
+       IF ( gases_available == ngases_salsa )  THEN
+          salsa_gases_from_chem = .TRUE.
+       ELSE
+          WRITE( message_string, * ) 'SALSA is run together with chemistry but not all gaseous '// &
+                                     'components are provided by kpp (H2SO4, HNO3, NH3, OCNV, OCSV)'
+       CALL message( 'check_parameters', 'PA0599', 1, 2, 0, 6, 0 )
+       ENDIF
+
+    ELSE
+
+       ALLOCATE( salsa_gas(ngases_salsa) )
+       ALLOCATE( gconc_1(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ngases_salsa),                 &
+                 gconc_2(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ngases_salsa),                 &
+                 gconc_3(nzb:nzt+1,nysg:nyng,nxlg:nxrg,ngases_salsa) )
+       gconc_1 = 0.0_wp
+       gconc_2 = 0.0_wp
+       gconc_3 = 0.0_wp
+
+       DO i = 1, ngases_salsa
+          salsa_gas(i)%conc(nzb:nzt+1,nysg:nyng,nxlg:nxrg)    => gconc_1(:,:,:,i)
+          salsa_gas(i)%conc_p(nzb:nzt+1,nysg:nyng,nxlg:nxrg)  => gconc_2(:,:,:,i)
+          salsa_gas(i)%tconc_m(nzb:nzt+1,nysg:nyng,nxlg:nxrg) => gconc_3(:,:,:,i)
+          ALLOCATE( salsa_gas(i)%flux_s(nzb+1:nzt,0:threads_per_task-1),       &
+                    salsa_gas(i)%diss_s(nzb+1:nzt,0:threads_per_task-1),       &
+                    salsa_gas(i)%flux_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),&
+                    salsa_gas(i)%diss_l(nzb+1:nzt,nys:nyn,0:threads_per_task-1),&
+                    salsa_gas(i)%init(nzb:nzt+1),                              &
+                    salsa_gas(i)%sums_ws_l(nzb:nzt+1,0:threads_per_task-1) )
+          salsa_gas(i)%init = nclim
+          IF ( include_emission )  THEN
+             ALLOCATE( salsa_gas(i)%source(nys:nys,nxl:nxr) )
+             salsa_gas(i)%source = 0.0_wp
+          ENDIF
+       ENDDO
+!
+!--    Surface fluxes: gtsws = gaseous tracer flux
+!
+!--    Horizontal surfaces: default type
+       DO  l = 0, 2   ! upward (l=0), downward (l=1) and model top (l=2)
+          ALLOCATE( surf_def_h(l)%gtsws( 1:surf_def_h(l)%ns, ngases_salsa ) )
+          surf_def_h(l)%gtsws = 0.0_wp
+       ENDDO
+!--    Horizontal surfaces: natural type
+       ALLOCATE( surf_lsm_h%gtsws( 1:surf_lsm_h%ns, ngases_salsa ) )
+       surf_lsm_h%gtsws = 0.0_wp
+!--    Horizontal surfaces: urban type
+       ALLOCATE( surf_usm_h%gtsws( 1:surf_usm_h%ns, ngases_salsa ) )
+       surf_usm_h%gtsws = 0.0_wp
+!
+!--    Vertical surfaces: northward (l=0), southward (l=1), eastward (l=2) and 
+!--    westward (l=3) facing
+       DO  l = 0, 3
+          ALLOCATE( surf_def_v(l)%gtsws( 1:surf_def_v(l)%ns, ngases_salsa ) )
+          surf_def_v(l)%gtsws = 0.0_wp
+          ALLOCATE( surf_lsm_v(l)%gtsws( 1:surf_lsm_v(l)%ns, ngases_salsa ) )
+          surf_lsm_v(l)%gtsws = 0.0_wp
+          ALLOCATE( surf_usm_v(l)%gtsws( 1:surf_usm_v(l)%ns, ngases_salsa ) )
+          surf_usm_v(l)%gtsws = 0.0_wp
+       ENDDO
+    ENDIF
+
+    IF ( ws_scheme_sca )  THEN
+
+       IF ( salsa )  THEN
+          ALLOCATE( sums_salsa_ws_l(nzb:nzt+1,0:threads_per_task-1) )
+          sums_salsa_ws_l = 0.0_wp
+       ENDIF
+
+    ENDIF
+!
+!-- Set control flags for decycling only at lateral boundary cores. Within the inner cores the
+!-- decycle flag is set to .FALSE.. Even though it does not affect the setting of chemistry boundary
+!-- conditions, this flag is used to set advection control flags appropriately.
+    decycle_salsa_lr = MERGE( decycle_salsa_lr, .FALSE., nxl == 0  .OR.  nxr == nx )
+    decycle_salsa_ns = MERGE( decycle_salsa_ns, .FALSE., nys == 0  .OR.  nyn == ny )
+!
+!-- Decycling can be applied separately for aerosol variables, while wind and other scalars may have
+!-- cyclic or nested boundary conditions. However, large gradients near the boundaries may produce
+!-- stationary numerical oscillations near the lateral boundaries when a higher-order scheme is
+!-- applied near these boundaries. To get rid-off this, set-up additional flags that control the
+!-- order of the scalar advection scheme near the lateral boundaries for passive scalars with
+!-- decycling.
+    IF ( scalar_advec == 'ws-scheme' )  THEN
+       ALLOCATE( salsa_advc_flags_s(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+!
+!--    In case of decycling, set Neuman boundary conditions for wall_flags_0 bit 31 instead of
+!--    cyclic boundary conditions. Bit 31 is used to identify extended degradation zones (please see
+!--    the following comment). Note, since several also other modules may access this bit but may
+!--    have other boundary conditions, the original value of wall_flags_0 bit 31 must not be
+!--    modified. Hence, store the boundary conditions directly on salsa_advc_flags_s.
+!--    salsa_advc_flags_s will be later overwritten in ws_init_flags_scalar and bit 31 won't be used
+!--    to control the numerical order.
+!--    Initialize with flag 31 only.
+       salsa_advc_flags_s = 0
+       salsa_advc_flags_s = MERGE( IBSET( salsa_advc_flags_s, 31 ), 0, BTEST( wall_flags_0, 31 ) )
+
+       IF ( decycle_salsa_ns )  THEN
+          IF ( nys == 0 )  THEN
+             DO  i = 1, nbgp
+                salsa_advc_flags_s(:,nys-i,:) = MERGE( IBSET( salsa_advc_flags_s(:,nys,:), 31 ),   &
+                                                       IBCLR( salsa_advc_flags_s(:,nys,:), 31 ),   &
+                                                       BTEST( salsa_advc_flags_s(:,nys,:), 31 ) )
+             ENDDO
+          ENDIF
+          IF ( nyn == ny )  THEN
+             DO  i = 1, nbgp
+                salsa_advc_flags_s(:,nyn+i,:) = MERGE( IBSET( salsa_advc_flags_s(:,nyn,:), 31 ),   &
+                                                       IBCLR( salsa_advc_flags_s(:,nyn,:), 31 ),   &
+                                                       BTEST( salsa_advc_flags_s(:,nyn,:), 31 ) )
+             ENDDO
+          ENDIF
+       ENDIF
+       IF ( decycle_salsa_lr )  THEN
+          IF ( nxl == 0 )  THEN
+             DO  i = 1, nbgp
+                salsa_advc_flags_s(:,:,nxl-i) = MERGE( IBSET( salsa_advc_flags_s(:,:,nxl), 31 ),   &
+                                                       IBCLR( salsa_advc_flags_s(:,:,nxl), 31 ),   &
+                                                       BTEST( salsa_advc_flags_s(:,:,nxl), 31 ) )
+             ENDDO
+          ENDIF
+          IF ( nxr == nx )  THEN
+             DO  i = 1, nbgp
+                salsa_advc_flags_s(:,:,nxr+i) = MERGE( IBSET( salsa_advc_flags_s(:,:,nxr), 31 ),   &
+                                                       IBCLR( salsa_advc_flags_s(:,:,nxr), 31 ),   &
+                                                       BTEST( salsa_advc_flags_s(:,:,nxr), 31 ) )
+             ENDDO
+          ENDIF
+       ENDIF
+!
+!--    To initialise the advection flags appropriately, pass the boundary flags to
+!--    ws_init_flags_scalar. The last argument in ws_init_flags_scalar indicates that a passive
+!--    scalar is being treated and the horizontal advection terms are degraded already 2 grid points
+!--    before the lateral boundary. Also, extended degradation zones are applied, where
+!--    horizontal advection of scalars is discretised by the first-order scheme at all grid points
+!--    in the vicinity of buildings (<= 3 grid points). Even though no building is within the
+!--    numerical stencil, the first-order scheme is used. At fourth and fifth grid points, the order
+!--    of the horizontal advection scheme is successively upgraded.
+!--    These degradations of the advection scheme are done to avoid stationary numerical
+!--    oscillations, which are responsible for high concentration maxima that may appear e.g. under
+!--    shear-free stable conditions.
+       CALL ws_init_flags_scalar( bc_dirichlet_l  .OR.  bc_radiation_l  .OR.  decycle_salsa_lr,    &
+                                  bc_dirichlet_n  .OR.  bc_radiation_n  .OR.  decycle_salsa_ns,    &
+                                  bc_dirichlet_r  .OR.  bc_radiation_r  .OR.  decycle_salsa_lr,    &
+                                  bc_dirichlet_s  .OR.  bc_radiation_s  .OR.  decycle_salsa_ns,    &
+                                  salsa_advc_flags_s, .TRUE. )
+    ENDIF
+
+
+ END SUBROUTINE salsa_init_arrays
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Initialization of SALSA. Based on salsa_initialize in UCLALES-SALSA.
+!> Subroutines salsa_initialize, SALSAinit and DiagInitAero in UCLALES-SALSA are
+!> also merged here.
+!------------------------------------------------------------------------------!
+ SUBROUTINE salsa_init
+
+    IMPLICIT NONE
+
+    INTEGER(iwp) :: i   !<
+    INTEGER(iwp) :: ib  !< loop index for aerosol number bins
+    INTEGER(iwp) :: ic  !< loop index for aerosol mass bins
+    INTEGER(iwp) :: ig  !< loop index for gases
+    INTEGER(iwp) :: j   !<
+
+    IF ( debug_output )  CALL debug_message( 'salsa_init', 'start' )
+
+    bin_low_limits = 0.0_wp
+    k_topo_top     = 0
+    nsect          = 0.0_wp
+    massacc        = 1.0_wp
 !
 !-- Initialise
-!
-!-- Aerosol size distribution (TYPE t_section)
-    aero(:)%dwet     = 1.0E-10_wp
-    aero(:)%veqh2o   = 1.0E-10_wp
-    aero(:)%numc     = nclim
-    aero(:)%core     = 1.0E-10_wp
-    DO ic = 1, maxspec+1    ! 1:SO4, 2:OC, 3:BC, 4:DU, 5:SS, 6:NO, 7:NH, 8:H2O
-       aero(:)%volc(ic) = 0.0_wp
-    ENDDO
-
     IF ( nldepo )  sedim_vd = 0.0_wp
 
@@ -1583,14 +1620,4 @@
 !-- Aerosol radius in each bin: dry and wet (m)
     ra_dry = 1.0E-10_wp
-!
-!-- Initialise aerosol tracers
-    aero(:)%vhilim   = 0.0_wp
-    aero(:)%vlolim   = 0.0_wp
-    aero(:)%vratiohi = 0.0_wp
-    aero(:)%vratiolo = 0.0_wp
-    aero(:)%dmid     = 0.0_wp
-!
-!-- Initialise the sectional particle size distribution
-    CALL set_sizebins
 !
 !-- Initialise location-dependent aerosol size distributions and chemical compositions:
@@ -1639,4 +1666,7 @@
        ENDIF
     ENDIF
+!
+!-- Partition and dissolutional growth by gaseous HNO3 and NH3
+    IF ( index_no > 0  .AND.  index_nh > 0  .AND.  index_so4 > 0 )  lspartition = .TRUE.
 
     IF ( debug_output )  CALL debug_message( 'salsa_init', 'end' )
@@ -1676,4 +1706,12 @@
 
     REAL(wp) ::  ratio_d  !< ratio of the upper and lower diameter of subranges
+
+    aero(:)%dwet     = 1.0E-10_wp
+    aero(:)%veqh2o   = 1.0E-10_wp
+    aero(:)%numc     = nclim
+    aero(:)%core     = 1.0E-10_wp
+    DO  cc = 1, maxspec+1    ! 1:SO4, 2:OC, 3:BC, 4:DU, 5:SS, 6:NO, 7:NH, 8:H2O
+       aero(:)%volc(cc) = 0.0_wp
+    ENDDO
 !
 !-- vlolim&vhilim: min & max *dry* volumes [fxm]
@@ -1737,10 +1775,12 @@
 
     USE netcdf_data_input_mod,                                                                     &
-        ONLY:  close_input_file, get_attribute, get_variable,                                      &
+        ONLY:  check_existence, close_input_file, get_attribute, get_variable,                     &
+               inquire_num_variables, inquire_variable_names,                                      &
                netcdf_data_input_get_dimension_length, open_read_file
 
     IMPLICIT NONE
 
-    CHARACTER(LEN=25), DIMENSION(:), ALLOCATABLE :: cc_name  !< chemical component name
+    CHARACTER(LEN=25),  DIMENSION(:), ALLOCATABLE ::  cc_name    !< chemical component name
+    CHARACTER(LEN=100), DIMENSION(:), ALLOCATABLE ::  var_names  !< variable names
 
     INTEGER(iwp) ::  ee        !< index: end
@@ -1753,11 +1793,12 @@
     INTEGER(iwp) ::  k         !< loop index: z-direction
     INTEGER(iwp) ::  lod_aero  !< level of detail of inital aerosol concentrations
-    INTEGER(iwp) ::  pr_nbins  !< Number of aerosol size bins in file
-    INTEGER(iwp) ::  pr_ncc    !< Number of aerosol chemical components in file
-    INTEGER(iwp) ::  pr_nz     !< Number of vertical grid-points in file
+    INTEGER(iwp) ::  num_vars  !< number of variables
+    INTEGER(iwp) ::  pr_nbins  !< number of aerosol size bins in file
+    INTEGER(iwp) ::  pr_ncc    !< number of aerosol chemical components in file
+    INTEGER(iwp) ::  pr_nz     !< number of vertical grid-points in file
     INTEGER(iwp) ::  prunmode  !< running mode of SALSA
     INTEGER(iwp) ::  ss        !< index: start
 
-    INTEGER(iwp), DIMENSION(maxspec) ::  cc_input_to_model
+    INTEGER(iwp), DIMENSION(maxspec) ::  cc_in2mod
 
     LOGICAL  ::  netcdf_extend = .FALSE. !< Flag: netcdf file exists
@@ -1770,5 +1811,5 @@
     REAL(wp), DIMENSION(0:nz+1) ::  pmfoc1a !< mass fraction of OC in 1a
 
-    REAL(wp), DIMENSION(0:nz+1,nbins_aerosol)   ::  pndist  !< size dist as a function of height (#/m3)
+    REAL(wp), DIMENSION(0:nz+1,nbins_aerosol)   ::  pndist  !< vertical profile of size dist. (#/m3)
     REAL(wp), DIMENSION(0:nz+1,maxspec)         ::  pmf2a   !< mass distributions in subrange 2a
     REAL(wp), DIMENSION(0:nz+1,maxspec)         ::  pmf2b   !< mass distributions in subrange 2b
@@ -1780,9 +1821,8 @@
     REAL(wp), DIMENSION(:,:), ALLOCATABLE ::  pr_mass_fracs_b  !< and b
 
-    cc_input_to_model = 0
+    cc_in2mod = 0
     prunmode = 1
 !
 !-- Bin mean aerosol particle volume (m3)
-    core(:) = 0.0_wp
     core(1:nbins_aerosol) = api6 * aero(1:nbins_aerosol)%dmid**3
 !
@@ -1806,5 +1846,12 @@
           CALL open_read_file( TRIM( input_file_dynamic ) // TRIM( coupling_char ), id_dyn )
 !
-!--       Inquire dimensions:
+!--       At first, inquire all variable names
+          CALL inquire_num_variables( id_dyn, num_vars )
+!
+!--       Allocate memory to store variable names
+          ALLOCATE( var_names(1:num_vars) )
+          CALL inquire_variable_names( id_dyn, var_names )
+!
+!--       Inquire vertical dimension and number of aerosol chemical components
           CALL netcdf_data_input_get_dimension_length( id_dyn, pr_nz, 'z' )
           IF ( pr_nz /= nz )  THEN
@@ -1824,26 +1871,33 @@
           CALL get_variable( id_dyn, 'z', pr_z )
 !
-!--       Read name and index of chemical components
-          CALL get_variable( id_dyn, 'composition_name', cc_name, pr_ncc )
+!--       Read the names of chemical components
+          IF ( check_existence( var_names, 'composition_name' ) )  THEN
+             CALL get_variable( id_dyn, 'composition_name', cc_name, pr_ncc )
+          ELSE
+             WRITE( message_string, * ) 'Missing composition_name in ' // TRIM( input_file_dynamic )
+             CALL message( 'aerosol_init', 'PA0655', 1, 2, 0, 6, 0 )
+          ENDIF
+!
+!--       Define the index of each chemical component in the model
           DO  ic = 1, pr_ncc
              SELECT CASE ( TRIM( cc_name(ic) ) )
                 CASE ( 'H2SO4', 'SO4', 'h2so4', 'so4' )
-                   cc_input_to_model(1) = ic
+                   cc_in2mod(1) = ic
                 CASE ( 'OC', 'oc' )
-                   cc_input_to_model(2) = ic
+                   cc_in2mod(2) = ic
                 CASE ( 'BC', 'bc' )
-                   cc_input_to_model(3) = ic
+                   cc_in2mod(3) = ic
                 CASE ( 'DU', 'du' )
-                   cc_input_to_model(4) = ic
+                   cc_in2mod(4) = ic
                 CASE ( 'SS', 'ss' )
-                   cc_input_to_model(5) = ic
+                   cc_in2mod(5) = ic
                 CASE ( 'HNO3', 'hno3', 'NO', 'no' )
-                   cc_input_to_model(6) = ic
+                   cc_in2mod(6) = ic
                 CASE ( 'NH3', 'nh3', 'NH', 'nh' )
-                   cc_input_to_model(7) = ic
+                   cc_in2mod(7) = ic
              END SELECT
           ENDDO
 
-          IF ( SUM( cc_input_to_model ) == 0 )  THEN
+          IF ( SUM( cc_in2mod ) == 0 )  THEN
              message_string = 'None of the aerosol chemical components in ' // TRIM(               &
                               input_file_dynamic ) // ' correspond to ones applied in SALSA.'
@@ -1852,6 +1906,12 @@
 !
 !--       Vertical profiles of mass fractions of different chemical components:
-          CALL get_variable( id_dyn, 'init_atmosphere_mass_fracs_a', pr_mass_fracs_a,              &
-                             0, pr_ncc-1, 0, pr_nz-1 )
+          IF ( check_existence( var_names, 'init_atmosphere_mass_fracs_a' ) )  THEN
+             CALL get_variable( id_dyn, 'init_atmosphere_mass_fracs_a', pr_mass_fracs_a,           &
+                                0, pr_ncc-1, 0, pr_nz-1 )
+          ELSE
+             WRITE( message_string, * ) 'Missing init_atmosphere_mass_fracs_a in ' //              &
+                                        TRIM( input_file_dynamic )
+             CALL message( 'aerosol_init', 'PA0656', 1, 2, 0, 6, 0 )
+          ENDIF
           CALL get_variable( id_dyn, 'init_atmosphere_mass_fracs_b', pr_mass_fracs_b,              &
                              0, pr_ncc-1, 0, pr_nz-1  )
@@ -1859,5 +1919,5 @@
 !--       Match the input data with the chemical composition applied in the model
           DO  ic = 1, maxspec
-             ss = cc_input_to_model(ic)
+             ss = cc_in2mod(ic)
              IF ( ss == 0 )  CYCLE
              pmf2a(nzb+1:nzt+1,ic) = pr_mass_fracs_a(nzb:nzt,ss)
@@ -1865,5 +1925,5 @@
           ENDDO
 !
-!--       Aerosol concentrations: lod=1 (total PM) or lod=2 (sectional number size distribution)
+!--       Aerosol concentrations: lod=1 (vertical profile of sectional number size distribution)
           CALL get_attribute( id_dyn, 'lod', lod_aero, .FALSE., 'init_atmosphere_aerosol' )
           IF ( lod_aero /= 1 )  THEN
@@ -3020,5 +3080,5 @@
 !--    Condensation
        IF ( lscnd )   THEN
-          CALL condensation( lo_aero, zgso4, zgocnv, zgocsv,  zghno3, zgnh3, in_cw(k), in_cs(k),      &
+          CALL condensation( lo_aero, zgso4, zgocnv, zgocsv,  zghno3, zgnh3, in_cw(k), in_cs(k),   &
                              in_t(k), in_p(k), dt_salsa, prtcl )
        ENDIF
@@ -3026,5 +3086,5 @@
 !--    Deposition
        IF ( lsdepo )  THEN
-          CALL deposition( lo_aero, in_t(k), in_adn(k), in_u(k), in_lad, kvis(k), schmidt_num(k,:),   &
+          CALL deposition( lo_aero, in_t(k), in_adn(k), in_u(k), in_lad, kvis(k), schmidt_num(k,:),&
                            vd(k,:) )
        ENDIF
@@ -3258,6 +3318,5 @@
 ! Description:
 ! ------------
-!> Set logical switches according to the host model state and user-specified 
-!> NAMELIST options.
+!> Set logical switches according to the salsa_parameters options.
 !> Juha Tonttila, FMI, 2014
 !> Only aerosol processes included, Mona Kurppa, UHel, 2017
@@ -3832,9 +3891,10 @@
 !
 !--    Brownian diffusion
-       v_bd = mag_u * c_brownian_diff * schmidt_num**( -0.66666666_wp ) *                             &
+       v_bd = mag_u * c_brownian_diff * schmidt_num**( -0.66666666_wp ) *                          &
               ( mag_u * par_l / kvis_a )**( -0.5_wp )
 !
 !--    Interception
-       v_in = mag_u * c_interception * diameter / par_l * ( 2.0_wp + LOG( 2.0_wp * par_l / diameter ) )
+       v_in = mag_u * c_interception * diameter / par_l *                                          &
+              ( 2.0_wp + LOG( 2.0_wp * par_l / diameter ) )
 !
 !--    Impaction: Petroff (2009) Eq. 18
@@ -4179,5 +4239,5 @@
     REAL(wp), DIMENSION(maxspec+1)     ::  zplusterm  !< coagulation gain in a bin (for each
                                                       !< chemical compound)
-    REAL(wp), DIMENSION(nbins_aerosol,nbins_aerosol) ::  zcc  !< updated coagulation coefficients (m3/s)
+    REAL(wp), DIMENSION(nbins_aerosol,nbins_aerosol) ::  zcc  !< updated coagulation coeff. (m3/s)
 
     TYPE(t_section), DIMENSION(nbins_aerosol), INTENT(inout) ::  paero  !< Aerosol properties
@@ -4186,7 +4246,6 @@
     zdpart_nn = 0.0_wp
 !
-!-- 1) Coagulation to coarse mode calculated in a simplified way: 
-!--    CoagSink ~ Dp in continuum subrange, thus we calculate 'effective' 
-!--    number concentration of coarse particles
+!-- 1) Coagulation to coarse mode calculated in a simplified way:
+!--    CoagSink ~ Dp in continuum subrange --> 'effective' number conc. of coarse particles
 
 !-- 2) Updating coagulation coefficients 
@@ -4418,5 +4477,5 @@
     fmdist = SQRT( tva(1)**2 + tva(2)**2 )
 !
-!-- 5) Coagulation coefficient = coalescence efficiency * collision kernel (m3/s) (eq. 15.33). 
+!-- 5) Coagulation coefficient = coalescence efficiency * collision kernel (m3/s) (eq. 15.33).
 !--    Here assumed coalescence efficiency 1!!
     coagc = flux(1) / ( mdiam / ( mdiam + fmdist) + flux(1) / flux(2) )
@@ -4632,5 +4691,5 @@
 !
 !--    5.1.2) Semivolatile organic compound: all bins except subrange 1
-       zcs_ocsv = SUM( zcolrate(start_subrange_2a:end_subrange_2b) ) !< sink for semi-volatile organics
+       zcs_ocsv = SUM( zcolrate(start_subrange_2a:end_subrange_2b) ) !< sink for semi-volatile org.
        IF ( pcocsv > 1.0E+10_wp  .AND.  zcs_ocsv > 1.0E-30  .AND. is_used( prtcl,'OC') )  THEN
 !
@@ -4849,4 +4908,8 @@
     zkocnv = 0.0_wp
 
+    zc_h2so4 = pc_sa * 1.0E-6_wp   ! sulphuric acid conc. to #/cm3
+    zc_org   = pc_ocnv * 1.0E-6_wp   ! conc. of non-volatile OC to #/cm3
+    zmixnh3  = pc_nh3 * ptemp * argas / ( ppres * avo )
+
     SELECT CASE ( nsnucl )
 !
